Merge ganeti-master-cleaner back into ganeti-cleaner
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Confd \
61         htools/Ganeti/HTools \
62         htools/Ganeti/HTools/Program \
63         htools/Ganeti/Query \
64         htest \
65         htest/Test \
66         htest/Test/Ganeti \
67         htest/Test/Ganeti/Confd \
68         htest/Test/Ganeti/HTools \
69         htest/Test/Ganeti/Query
70
71 DIRS = \
72         $(HTOOLS_DIRS) \
73         autotools \
74         daemons \
75         devel \
76         doc \
77         doc/examples \
78         doc/examples/gnt-debug \
79         doc/examples/hooks \
80         htest/data \
81         htest/data/rapi \
82         htest/shelltests \
83         lib \
84         lib/build \
85         lib/client \
86         lib/confd \
87         lib/http \
88         lib/hypervisor \
89         lib/impexpd \
90         lib/masterd \
91         lib/rapi \
92         lib/server \
93         lib/tools \
94         lib/utils \
95         lib/watcher \
96         man \
97         qa \
98         test \
99         test/data \
100         test/data/ovfdata \
101         test/data/ovfdata/other \
102         tools
103
104 BUILDTIME_DIR_AUTOCREATE = \
105         scripts \
106         $(APIDOC_DIR) \
107         $(APIDOC_HS_DIR) \
108         $(APIDOC_HS_DIR)/Ganeti \
109         $(APIDOC_HS_DIR)/Ganeti/Confd \
110         $(APIDOC_HS_DIR)/Ganeti/HTools \
111         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
112         $(APIDOC_HS_DIR)/Ganeti/Query \
113         $(APIDOC_PY_DIR) \
114         $(COVERAGE_DIR) \
115         $(COVERAGE_HS_DIR) \
116         $(COVERAGE_PY_DIR) \
117         .hpc
118
119 BUILDTIME_DIRS = \
120         $(BUILDTIME_DIR_AUTOCREATE) \
121         doc/html
122
123 DIRCHECK_EXCLUDE = \
124         $(BUILDTIME_DIRS) \
125         ganeti-[0-9]*.[0-9]*.[0-9]* \
126         doc/html/_*
127
128 # some helper vars
129 COVERAGE_DIR = doc/coverage
130 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 APIDOC_DIR = doc/api
133 APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135
136 MAINTAINERCLEANFILES = \
137         $(docpng) \
138         $(maninput) \
139         doc/install-quick.rst \
140         doc/news.rst \
141         doc/upgrade.rst \
142         vcs-version
143
144 maintainer-clean-local:
145         rm -rf $(BUILDTIME_DIRS)
146
147 CLEANFILES = \
148         $(addsuffix /*.py[co],$(DIRS)) \
149         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
151         $(PYTHON_BOOTSTRAP) \
152         epydoc.conf \
153         $(REPLACE_VARS_SED) \
154         $(SHELL_ENV_INIT) \
155         daemons/daemon-util \
156         daemons/ganeti-cleaner \
157         devel/upload \
158         $(BUILT_EXAMPLES) \
159         doc/examples/bash_completion \
160         doc/examples/bash_completion-debug \
161         lib/_generated_rpc.py \
162         $(man_MANS) \
163         $(manhtml) \
164         tools/kvm-ifup \
165         tools/vcluster-setup \
166         stamp-directories \
167         stamp-srclinks \
168         $(nodist_pkgpython_PYTHON) \
169         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
170         $(HS_BUILT_TEST_HELPERS) \
171         htools/ganeti-confd \
172         .hpc/*.mix htools/*.tix htest/*.tix \
173         doc/hs-lint.html
174
175 GENERATED_FILES = \
176         $(built_base_sources) \
177         $(BUILT_PYTHON_SOURCES) \
178         $(PYTHON_BOOTSTRAP)
179
180 HTOOLS_GENERATED_FILES =
181 if WANT_HTOOLS
182 HTOOLS_GENERATED_FILES += $(HS_PROGS)
183 if ENABLE_CONFD
184 HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
185 endif
186 endif
187
188 built_base_sources = \
189         stamp-directories \
190         stamp-srclinks
191
192 built_python_base_sources = \
193         lib/_autoconf.py \
194         lib/_vcsversion.py
195
196 BUILT_PYTHON_SOURCES = \
197         $(built_python_base_sources) \
198         lib/_generated_rpc.py
199
200 # Generating the RPC wrappers depends on many things, so make sure
201 # it's built at the end of the built sources
202 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
203
204 # these are all built from the underlying %.in sources
205 BUILT_EXAMPLES = \
206         doc/examples/ganeti-kvm-poweroff.initd \
207         doc/examples/ganeti.cron \
208         doc/examples/ganeti.initd \
209         doc/examples/gnt-config-backup \
210         doc/examples/hooks/ipsec
211
212 nodist_pkgpython_PYTHON = \
213         $(BUILT_PYTHON_SOURCES)
214
215 noinst_PYTHON = \
216         lib/build/__init__.py \
217         lib/build/shell_example_lexer.py \
218         lib/build/sphinx_ext.py
219
220 pkgpython_PYTHON = \
221         lib/__init__.py \
222         lib/asyncnotifier.py \
223         lib/backend.py \
224         lib/bdev.py \
225         lib/bootstrap.py \
226         lib/cli.py \
227         lib/cmdlib.py \
228         lib/compat.py \
229         lib/config.py \
230         lib/constants.py \
231         lib/daemon.py \
232         lib/errors.py \
233         lib/ht.py \
234         lib/jqueue.py \
235         lib/jstore.py \
236         lib/locking.py \
237         lib/luxi.py \
238         lib/mcpu.py \
239         lib/netutils.py \
240         lib/objects.py \
241         lib/objectutils.py \
242         lib/opcodes.py \
243         lib/ovf.py \
244         lib/pathutils.py \
245         lib/qlang.py \
246         lib/query.py \
247         lib/rpc.py \
248         lib/rpc_defs.py \
249         lib/runtime.py \
250         lib/serializer.py \
251         lib/ssconf.py \
252         lib/ssh.py \
253         lib/storage.py \
254         lib/uidpool.py \
255         lib/vcluster.py \
256         lib/workerpool.py
257
258 client_PYTHON = \
259         lib/client/__init__.py \
260         lib/client/gnt_backup.py \
261         lib/client/gnt_cluster.py \
262         lib/client/gnt_debug.py \
263         lib/client/gnt_group.py \
264         lib/client/gnt_instance.py \
265         lib/client/gnt_job.py \
266         lib/client/gnt_node.py \
267         lib/client/gnt_os.py
268
269 hypervisor_PYTHON = \
270         lib/hypervisor/__init__.py \
271         lib/hypervisor/hv_base.py \
272         lib/hypervisor/hv_chroot.py \
273         lib/hypervisor/hv_fake.py \
274         lib/hypervisor/hv_kvm.py \
275         lib/hypervisor/hv_lxc.py \
276         lib/hypervisor/hv_xen.py
277
278 rapi_PYTHON = \
279         lib/rapi/__init__.py \
280         lib/rapi/baserlib.py \
281         lib/rapi/client.py \
282         lib/rapi/client_utils.py \
283         lib/rapi/connector.py \
284         lib/rapi/rlib2.py \
285         lib/rapi/testutils.py
286
287 http_PYTHON = \
288         lib/http/__init__.py \
289         lib/http/auth.py \
290         lib/http/client.py \
291         lib/http/server.py
292
293 confd_PYTHON = \
294         lib/confd/__init__.py \
295         lib/confd/client.py
296
297 masterd_PYTHON = \
298         lib/masterd/__init__.py \
299         lib/masterd/iallocator.py \
300         lib/masterd/instance.py
301
302 impexpd_PYTHON = \
303         lib/impexpd/__init__.py
304
305 watcher_PYTHON = \
306         lib/watcher/__init__.py \
307         lib/watcher/nodemaint.py \
308         lib/watcher/state.py
309
310 server_PYTHON = \
311         lib/server/__init__.py \
312         lib/server/masterd.py \
313         lib/server/noded.py \
314         lib/server/rapi.py
315
316 pytools_PYTHON = \
317         lib/tools/__init__.py \
318         lib/tools/ensure_dirs.py
319
320 utils_PYTHON = \
321         lib/utils/__init__.py \
322         lib/utils/algo.py \
323         lib/utils/filelock.py \
324         lib/utils/hash.py \
325         lib/utils/io.py \
326         lib/utils/log.py \
327         lib/utils/mlock.py \
328         lib/utils/nodesetup.py \
329         lib/utils/process.py \
330         lib/utils/retry.py \
331         lib/utils/text.py \
332         lib/utils/wrapper.py \
333         lib/utils/x509.py
334
335 docrst = \
336         doc/admin.rst \
337         doc/cluster-merge.rst \
338         doc/design-2.0.rst \
339         doc/design-2.1.rst \
340         doc/design-2.2.rst \
341         doc/design-2.3.rst \
342         doc/design-2.4.rst \
343         doc/design-2.5.rst \
344         doc/design-autorepair.rst \
345         doc/design-bulk-create.rst \
346         doc/design-chained-jobs.rst \
347         doc/design-cpu-pinning.rst \
348         doc/design-draft.rst \
349         doc/design-htools-2.3.rst \
350         doc/design-http-server.rst \
351         doc/design-impexp2.rst \
352         doc/design-lu-generated-jobs.rst \
353         doc/design-multi-reloc.rst \
354         doc/design-network.rst \
355         doc/design-node-state-cache.rst \
356         doc/design-oob.rst \
357         doc/design-ovf-support.rst \
358         doc/design-partitioned.rst \
359         doc/design-query-splitting.rst \
360         doc/design-query2.rst \
361         doc/design-resource-model.rst \
362         doc/design-shared-storage.rst \
363         doc/design-virtual-clusters.rst \
364         doc/design-x509-ca.rst \
365         doc/devnotes.rst \
366         doc/glossary.rst \
367         doc/hooks.rst \
368         doc/iallocator.rst \
369         doc/index.rst \
370         doc/install-quick.rst \
371         doc/install.rst \
372         doc/locking.rst \
373         doc/move-instance.rst \
374         doc/news.rst \
375         doc/ovfconverter.rst \
376         doc/rapi.rst \
377         doc/security.rst \
378         doc/upgrade.rst \
379         doc/virtual-cluster.rst \
380         doc/walkthrough.rst
381
382 HS_PROGS = htools/htools
383 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
384 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
385
386 HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
387 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
388 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
389
390 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
391 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
392 HEXTRA =
393 # internal extra flags (used for htest/test mainly)
394 HEXTRA_INT =
395 # exclude options for coverage reports
396 HPCEXCL = --exclude Main \
397         --exclude Ganeti.Constants \
398         --exclude Ganeti.HTools.QC \
399         --exclude Ganeti.THH \
400         --exclude Ganeti.Version \
401         --exclude Test.Ganeti.TestCommon \
402         --exclude Test.Ganeti.TestHTools \
403         --exclude Test.Ganeti.TestHelper \
404         --exclude Test.Ganeti.TestImports \
405         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
406
407 HS_LIB_SRCS = \
408         htools/Ganeti/BasicTypes.hs \
409         htools/Ganeti/Common.hs \
410         htools/Ganeti/Compat.hs \
411         htools/Ganeti/Confd.hs \
412         htools/Ganeti/Confd/Server.hs \
413         htools/Ganeti/Confd/Utils.hs \
414         htools/Ganeti/Config.hs \
415         htools/Ganeti/Daemon.hs \
416         htools/Ganeti/HTools/CLI.hs \
417         htools/Ganeti/HTools/Cluster.hs \
418         htools/Ganeti/HTools/Container.hs \
419         htools/Ganeti/HTools/ExtLoader.hs \
420         htools/Ganeti/HTools/Group.hs \
421         htools/Ganeti/HTools/IAlloc.hs \
422         htools/Ganeti/HTools/Instance.hs \
423         htools/Ganeti/HTools/Loader.hs \
424         htools/Ganeti/HTools/Luxi.hs \
425         htools/Ganeti/HTools/Node.hs \
426         htools/Ganeti/HTools/PeerMap.hs \
427         htools/Ganeti/HTools/Program.hs \
428         htools/Ganeti/HTools/Program/Hail.hs \
429         htools/Ganeti/HTools/Program/Hbal.hs \
430         htools/Ganeti/HTools/Program/Hcheck.hs \
431         htools/Ganeti/HTools/Program/Hinfo.hs \
432         htools/Ganeti/HTools/Program/Hscan.hs \
433         htools/Ganeti/HTools/Program/Hspace.hs \
434         htools/Ganeti/HTools/Rapi.hs \
435         htools/Ganeti/HTools/Simu.hs \
436         htools/Ganeti/HTools/Text.hs \
437         htools/Ganeti/HTools/Types.hs \
438         htools/Ganeti/Hash.hs \
439         htools/Ganeti/JSON.hs \
440         htools/Ganeti/Jobs.hs \
441         htools/Ganeti/Logging.hs \
442         htools/Ganeti/Luxi.hs \
443         htools/Ganeti/Objects.hs \
444         htools/Ganeti/OpCodes.hs \
445         htools/Ganeti/Path.hs \
446         htools/Ganeti/Query/Common.hs \
447         htools/Ganeti/Query/Filter.hs \
448         htools/Ganeti/Query/Group.hs \
449         htools/Ganeti/Query/Language.hs \
450         htools/Ganeti/Query/Node.hs \
451         htools/Ganeti/Query/Query.hs \
452         htools/Ganeti/Query/Server.hs \
453         htools/Ganeti/Query/Types.hs \
454         htools/Ganeti/Rpc.hs \
455         htools/Ganeti/Runtime.hs \
456         htools/Ganeti/Ssconf.hs \
457         htools/Ganeti/THH.hs \
458         htools/Ganeti/Utils.hs
459
460 HS_TEST_SRCS = \
461         htest/Test/Ganeti/BasicTypes.hs \
462         htest/Test/Ganeti/Common.hs \
463         htest/Test/Ganeti/Confd/Utils.hs \
464         htest/Test/Ganeti/Daemon.hs \
465         htest/Test/Ganeti/HTools/CLI.hs \
466         htest/Test/Ganeti/HTools/Cluster.hs \
467         htest/Test/Ganeti/HTools/Container.hs \
468         htest/Test/Ganeti/HTools/Instance.hs \
469         htest/Test/Ganeti/HTools/Loader.hs \
470         htest/Test/Ganeti/HTools/Node.hs \
471         htest/Test/Ganeti/HTools/PeerMap.hs \
472         htest/Test/Ganeti/HTools/Simu.hs \
473         htest/Test/Ganeti/HTools/Text.hs \
474         htest/Test/Ganeti/HTools/Types.hs \
475         htest/Test/Ganeti/JSON.hs \
476         htest/Test/Ganeti/Jobs.hs \
477         htest/Test/Ganeti/Luxi.hs \
478         htest/Test/Ganeti/Objects.hs \
479         htest/Test/Ganeti/OpCodes.hs \
480         htest/Test/Ganeti/Query/Filter.hs \
481         htest/Test/Ganeti/Query/Language.hs \
482         htest/Test/Ganeti/Query/Query.hs \
483         htest/Test/Ganeti/Rpc.hs \
484         htest/Test/Ganeti/Ssconf.hs \
485         htest/Test/Ganeti/TestCommon.hs \
486         htest/Test/Ganeti/TestHTools.hs \
487         htest/Test/Ganeti/TestHelper.hs \
488         htest/Test/Ganeti/Utils.hs
489
490 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
491
492 HS_BUILT_SRCS = \
493         htest/Test/Ganeti/TestImports.hs \
494         htools/Ganeti/Constants.hs \
495         htools/Ganeti/Version.hs
496 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
497
498 $(RUN_IN_TEMPDIR): | stamp-directories
499
500 # Note: we use here an order-only prerequisite, as the contents of
501 # _autoconf.py are not actually influencing the html build output: it
502 # has to exist in order for the sphinx module to be loaded
503 # successfully, but we certainly don't want the docs to be rebuilt if
504 # it changes
505 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
506         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
507         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
508         | $(BUILT_PYTHON_SOURCES)
509         @test -n "$(SPHINX)" || \
510             { echo 'sphinx-build' not found during configure; exit 1; }
511         @mkdir_p@ $(dir $@)
512         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
513             -d . \
514             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
515             -D release="$(PACKAGE_VERSION)" \
516             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
517         rm -f doc/html/.buildinfo doc/html/objects.inv
518         touch $@
519
520 doc/html: doc/html/index.html
521
522 doc/install-quick.rst: INSTALL
523 doc/news.rst: NEWS
524 doc/upgrade.rst: UPGRADE
525
526 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
527         set -e; \
528         { echo '.. This file is automatically updated at build time from $<.'; \
529           echo '.. Do not edit.'; \
530           echo; \
531           cat $<; \
532         } > $@
533
534 docdot = \
535         doc/arch-2.0.dot \
536         doc/design-2.1-lock-acquire.dot \
537         doc/design-2.1-lock-release.dot
538
539 docpng = $(patsubst %.dot,%.png,$(docdot))
540
541 # Things to build but not to install (add it to EXTRA_DIST if it should be
542 # distributed)
543 noinst_DATA = \
544         devel/upload \
545         doc/html \
546         $(BUILT_EXAMPLES) \
547         doc/examples/bash_completion \
548         doc/examples/bash_completion-debug \
549         $(manhtml)
550
551 gnt_scripts = \
552         scripts/gnt-backup \
553         scripts/gnt-cluster \
554         scripts/gnt-debug \
555         scripts/gnt-group \
556         scripts/gnt-instance \
557         scripts/gnt-job \
558         scripts/gnt-node \
559         scripts/gnt-os
560
561 PYTHON_BOOTSTRAP_SBIN = \
562         daemons/ganeti-masterd \
563         daemons/ganeti-noded \
564         daemons/ganeti-rapi \
565         daemons/ganeti-watcher \
566         $(gnt_scripts)
567
568 PYTHON_BOOTSTRAP = \
569         $(PYTHON_BOOTSTRAP_SBIN) \
570         tools/ensure-dirs
571
572 qa_scripts = \
573         qa/__init__.py \
574         qa/ganeti-qa.py \
575         qa/qa_cluster.py \
576         qa/qa_config.py \
577         qa/qa_daemon.py \
578         qa/qa_env.py \
579         qa/qa_error.py \
580         qa/qa_group.py \
581         qa/qa_instance.py \
582         qa/qa_job.py \
583         qa/qa_node.py \
584         qa/qa_os.py \
585         qa/qa_rapi.py \
586         qa/qa_tags.py \
587         qa/qa_utils.py
588
589 bin_SCRIPTS =
590 if WANT_HTOOLS
591 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
592 install-exec-hook:
593         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
594 # FIXME: this is a hardcoded logic, instead of auto-resolving
595         $(LN_S) -f ../../../bin/htools \
596                    $(DESTDIR)$(iallocatorsdir)/hail
597         for role in $(HS_BIN_ROLES); do \
598                 $(LN_S) -f htools \
599                            $(DESTDIR)$(bindir)/$$role ; \
600         done
601 endif
602
603 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
604         @if [ -z "$(HTOOLS)" ]; then \
605           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
606           exit 1; \
607         fi
608         @if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
609           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
610           exit 1; \
611         fi
612         @rm -f $(notdir $@).tix
613         $(GHC) --make \
614           $(HFLAGS) \
615           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
616           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
617           $(HEXTRA) $(HEXTRA_INT) $@
618         @touch "$@"
619
620 # for the htest/test binary, we need to enable profiling/coverage
621 htest/test: HEXTRA_INT=-fhpc -ihtest
622
623 # we compile the hpc-htools binary with the program coverage
624 htest/hpc-htools: HEXTRA_INT=-fhpc
625
626 # test dependency
627 htest/offline-tests.sh: htest/hpc-htools
628
629 # rules for building profiling-enabled versions of the haskell
630 # programs: hs-prof does the full two-step build, whereas
631 # hs-prof-quick does only the final rebuild (hs-prof must have been
632 # run before)
633 .PHONY: hs-prof hs-prof-quick
634 hs-prof:
635         $(MAKE) $(AM_MAKEFLAGS) clean
636         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
637         rm -f $(HS_ALL_PROGS)
638         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
639
640 hs-prof-quick:
641         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
642
643 dist_sbin_SCRIPTS = \
644         tools/ganeti-listrunner
645
646 nodist_sbin_SCRIPTS = \
647         $(PYTHON_BOOTSTRAP_SBIN) \
648         daemons/ganeti-cleaner
649
650 if ENABLE_CONFD
651 htools/ganeti-confd: htools/hconfd
652         cp -f $< $@
653
654 nodist_sbin_SCRIPTS += htools/ganeti-confd
655 endif
656
657 python_scripts = \
658         tools/burnin \
659         tools/cfgshell \
660         tools/cfgupgrade \
661         tools/cfgupgrade12 \
662         tools/cluster-merge \
663         tools/confd-client \
664         tools/fmtjson \
665         tools/lvmstrap \
666         tools/move-instance \
667         tools/ovfconverter \
668         tools/sanitize-config \
669         tools/setup-ssh
670
671 dist_tools_SCRIPTS = \
672         $(python_scripts) \
673         tools/kvm-console-wrapper \
674         tools/master-ip-setup \
675         tools/xm-console-wrapper
676
677 nodist_tools_SCRIPTS = \
678         tools/vcluster-setup
679
680 pkglib_python_scripts = \
681         daemons/import-export \
682         tools/check-cert-expired
683
684 nodist_pkglib_python_scripts = \
685         tools/ensure-dirs
686
687 myexeclib_SCRIPTS = \
688         daemons/daemon-util \
689         tools/kvm-ifup \
690         $(pkglib_python_scripts)
691
692 nodist_myexeclib_SCRIPTS = \
693         $(nodist_pkglib_python_scripts)
694
695 EXTRA_DIST = \
696         NEWS \
697         UPGRADE \
698         epydoc.conf.in \
699         pylintrc \
700         autotools/build-bash-completion \
701         autotools/build-rpc \
702         autotools/check-header \
703         autotools/check-imports \
704         autotools/check-man-dashes \
705         autotools/check-man-warnings \
706         autotools/check-news \
707         autotools/check-python-code \
708         autotools/check-tar \
709         autotools/check-version \
710         autotools/convert-constants \
711         autotools/docpp \
712         autotools/gen-coverage \
713         autotools/testrunner \
714         autotools/wrong-hardcoded-paths \
715         $(RUN_IN_TEMPDIR) \
716         daemons/daemon-util.in \
717         daemons/ganeti-cleaner.in \
718         $(pkglib_python_scripts) \
719         devel/upload.in \
720         tools/kvm-ifup.in \
721         tools/vcluster-setup.in \
722         $(docdot) \
723         $(docpng) \
724         $(docrst) \
725         doc/conf.py \
726         doc/html \
727         $(BUILT_EXAMPLES:%=%.in) \
728         doc/examples/ganeti.default \
729         doc/examples/ganeti.default-debug \
730         doc/examples/hooks/ethers \
731         doc/examples/gnt-debug/README \
732         doc/examples/gnt-debug/delay0.json \
733         doc/examples/gnt-debug/delay50.json \
734         test/lockperf.py \
735         test/testutils.py \
736         test/mocks.py \
737         $(dist_TESTS) \
738         $(TEST_FILES) \
739         man/footer.rst \
740         $(manrst) \
741         $(maninput) \
742         qa/qa-sample.json \
743         $(qa_scripts) \
744         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
745         $(HS_PROG_SRCS) \
746         htools/lint-hints.hs \
747         htest/cli-tests-defs.sh \
748         htest/offline-test.sh
749
750 man_MANS = \
751         man/ganeti-cleaner.8 \
752         man/ganeti-confd.8 \
753         man/ganeti-listrunner.8 \
754         man/ganeti-masterd.8 \
755         man/ganeti-noded.8 \
756         man/ganeti-os-interface.7 \
757         man/ganeti-rapi.8 \
758         man/ganeti-watcher.8 \
759         man/ganeti.7 \
760         man/gnt-backup.8 \
761         man/gnt-cluster.8 \
762         man/gnt-debug.8 \
763         man/gnt-group.8 \
764         man/gnt-instance.8 \
765         man/gnt-job.8 \
766         man/gnt-node.8 \
767         man/gnt-os.8 \
768         man/hail.1 \
769         man/hbal.1 \
770         man/hcheck.1 \
771         man/hinfo.1 \
772         man/hscan.1 \
773         man/hspace.1 \
774         man/htools.1
775
776 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
777 manhtml = $(patsubst %.rst,%.html,$(manrst))
778 mangen = $(patsubst %.rst,%.gen,$(manrst))
779 maninput = \
780         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
781         $(patsubst %.html,%.html.in,$(manhtml)) \
782         man/footer.man man/footer.html $(mangen)
783
784 TEST_FILES = \
785         htest/data/common-suffix.data \
786         htest/data/hail-alloc-drbd.json \
787         htest/data/hail-change-group.json \
788         htest/data/hail-invalid-reloc.json \
789         htest/data/hail-node-evac.json \
790         htest/data/hail-reloc-drbd.json \
791         htest/data/hbal-split-insts.data \
792         htest/data/invalid-node.data \
793         htest/data/missing-resources.data \
794         htest/data/rapi/groups.json \
795         htest/data/rapi/info.json \
796         htest/data/rapi/instances.json \
797         htest/data/rapi/nodes.json \
798         htest/shelltests/htools-balancing.test \
799         htest/shelltests/htools-basic.test \
800         htest/shelltests/htools-dynutil.test \
801         htest/shelltests/htools-excl.test \
802         htest/shelltests/htools-hail.test \
803         htest/shelltests/htools-hspace.test \
804         htest/shelltests/htools-invalid.test \
805         htest/shelltests/htools-multi-group.test \
806         htest/shelltests/htools-no-backend.test \
807         htest/shelltests/htools-rapi.test \
808         htest/shelltests/htools-single-group.test \
809         htest/shelltests/htools-text-backend.test \
810         test/data/bdev-drbd-8.0.txt \
811         test/data/bdev-drbd-8.3.txt \
812         test/data/bdev-drbd-disk.txt \
813         test/data/bdev-drbd-net-ip4.txt \
814         test/data/bdev-drbd-net-ip6.txt \
815         test/data/cert1.pem \
816         test/data/ip-addr-show-dummy0.txt \
817         test/data/ip-addr-show-lo-ipv4.txt \
818         test/data/ip-addr-show-lo-ipv6.txt \
819         test/data/ip-addr-show-lo-oneline-ipv4.txt \
820         test/data/ip-addr-show-lo-oneline-ipv6.txt \
821         test/data/ip-addr-show-lo-oneline.txt \
822         test/data/ip-addr-show-lo.txt \
823         test/data/kvm_0.12.5_help.txt \
824         test/data/kvm_0.15.90_help.txt \
825         test/data/kvm_0.9.1_help.txt \
826         test/data/kvm_1.0_help.txt \
827         test/data/ovfdata/compr_disk.vmdk.gz \
828         test/data/ovfdata/config.ini \
829         test/data/ovfdata/corrupted_resources.ovf \
830         test/data/ovfdata/empty.ini \
831         test/data/ovfdata/empty.ovf \
832         test/data/ovfdata/ganeti.mf \
833         test/data/ovfdata/ganeti.ovf \
834         test/data/ovfdata/gzip_disk.ovf \
835         test/data/ovfdata/new_disk.vmdk \
836         test/data/ovfdata/no_disk.ini \
837         test/data/ovfdata/no_disk_in_ref.ovf \
838         test/data/ovfdata/no_os.ini \
839         test/data/ovfdata/no_ovf.ova \
840         test/data/ovfdata/other/rawdisk.raw \
841         test/data/ovfdata/ova.ova \
842         test/data/ovfdata/rawdisk.raw \
843         test/data/ovfdata/second_disk.vmdk \
844         test/data/ovfdata/unsafe_path.ini \
845         test/data/ovfdata/virtualbox.ovf \
846         test/data/ovfdata/wrong_config.ini \
847         test/data/ovfdata/wrong_extension.ovd \
848         test/data/ovfdata/wrong_manifest.mf \
849         test/data/ovfdata/wrong_manifest.ovf \
850         test/data/ovfdata/wrong_ova.ova \
851         test/data/ovfdata/wrong_xml.ovf \
852         test/data/proc_drbd8.txt \
853         test/data/proc_drbd80-emptyline.txt \
854         test/data/proc_drbd83.txt \
855         test/data/proc_drbd83_sync.txt \
856         test/data/proc_drbd83_sync_krnl2.6.39.txt \
857         test/data/sys_drbd_usermode_helper.txt \
858         test/data/vgreduce-removemissing-2.02.02.txt \
859         test/data/vgreduce-removemissing-2.02.66-fail.txt \
860         test/data/vgreduce-removemissing-2.02.66-ok.txt \
861         test/data/vgs-missing-pvs-2.02.02.txt \
862         test/data/vgs-missing-pvs-2.02.66.txt \
863         test/ganeti-cli.test \
864         test/gnt-cli.test \
865         test/import-export_unittest-helper
866
867 python_tests = \
868         doc/examples/rapi_testutils.py \
869         test/cfgupgrade_unittest.py \
870         test/docs_unittest.py \
871         test/ganeti.asyncnotifier_unittest.py \
872         test/ganeti.backend_unittest.py \
873         test/ganeti.bdev_unittest.py \
874         test/ganeti.cli_unittest.py \
875         test/ganeti.client.gnt_cluster_unittest.py \
876         test/ganeti.client.gnt_instance_unittest.py \
877         test/ganeti.cmdlib_unittest.py \
878         test/ganeti.compat_unittest.py \
879         test/ganeti.confd.client_unittest.py \
880         test/ganeti.config_unittest.py \
881         test/ganeti.constants_unittest.py \
882         test/ganeti.daemon_unittest.py \
883         test/ganeti.errors_unittest.py \
884         test/ganeti.hooks_unittest.py \
885         test/ganeti.ht_unittest.py \
886         test/ganeti.http_unittest.py \
887         test/ganeti.hypervisor.hv_chroot_unittest.py \
888         test/ganeti.hypervisor.hv_fake_unittest.py \
889         test/ganeti.hypervisor.hv_kvm_unittest.py \
890         test/ganeti.hypervisor.hv_lxc_unittest.py \
891         test/ganeti.hypervisor.hv_xen_unittest.py \
892         test/ganeti.hypervisor_unittest.py \
893         test/ganeti.impexpd_unittest.py \
894         test/ganeti.jqueue_unittest.py \
895         test/ganeti.jstore_unittest.py \
896         test/ganeti.locking_unittest.py \
897         test/ganeti.luxi_unittest.py \
898         test/ganeti.masterd.iallocator_unittest.py \
899         test/ganeti.masterd.instance_unittest.py \
900         test/ganeti.mcpu_unittest.py \
901         test/ganeti.netutils_unittest.py \
902         test/ganeti.objects_unittest.py \
903         test/ganeti.objectutils_unittest.py \
904         test/ganeti.opcodes_unittest.py \
905         test/ganeti.ovf_unittest.py \
906         test/ganeti.qlang_unittest.py \
907         test/ganeti.query_unittest.py \
908         test/ganeti.rapi.baserlib_unittest.py \
909         test/ganeti.rapi.client_unittest.py \
910         test/ganeti.rapi.resources_unittest.py \
911         test/ganeti.rapi.rlib2_unittest.py \
912         test/ganeti.rapi.testutils_unittest.py \
913         test/ganeti.rpc_unittest.py \
914         test/ganeti.runtime_unittest.py \
915         test/ganeti.serializer_unittest.py \
916         test/ganeti.ssh_unittest.py \
917         test/ganeti.storage_unittest.py \
918         test/ganeti.tools.ensure_dirs_unittest.py \
919         test/ganeti.uidpool_unittest.py \
920         test/ganeti.utils.algo_unittest.py \
921         test/ganeti.utils.filelock_unittest.py \
922         test/ganeti.utils.hash_unittest.py \
923         test/ganeti.utils.io_unittest-runasroot.py \
924         test/ganeti.utils.io_unittest.py \
925         test/ganeti.utils.log_unittest.py \
926         test/ganeti.utils.mlock_unittest.py \
927         test/ganeti.utils.nodesetup_unittest.py \
928         test/ganeti.utils.process_unittest.py \
929         test/ganeti.utils.retry_unittest.py \
930         test/ganeti.utils.text_unittest.py \
931         test/ganeti.utils.wrapper_unittest.py \
932         test/ganeti.utils.x509_unittest.py \
933         test/ganeti.utils_unittest.py \
934         test/ganeti.vcluster_unittest.py \
935         test/ganeti.workerpool_unittest.py \
936         test/pycurl_reset_unittest.py \
937         test/qa.qa_config_unittest.py \
938         test/tempfile_fork_unittest.py
939
940 haskell_tests = htest/test
941
942 dist_TESTS = \
943         test/check-cert-expired_unittest.bash \
944         test/daemon-util_unittest.bash \
945         test/ganeti-cleaner_unittest.bash \
946         test/import-export_unittest.bash \
947         test/cli-test.bash \
948         test/bash_completion.bash \
949         $(python_tests)
950
951 nodist_TESTS =
952 check_SCRIPTS =
953
954 if WANT_HTOOLSTESTS
955 nodist_TESTS += $(haskell_tests)
956 dist_TESTS += htest/offline-test.sh
957 check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
958 endif
959
960 TESTS = $(dist_TESTS) $(nodist_TESTS)
961
962 # Environment for all tests
963 PLAIN_TESTS_ENVIRONMENT = \
964         PYTHONPATH=. \
965         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
966         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
967         $(RUN_IN_TEMPDIR)
968
969 # Environment for tests run by automake
970 TESTS_ENVIRONMENT = \
971         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
972
973 all_python_code = \
974         $(dist_sbin_SCRIPTS) \
975         $(python_scripts) \
976         $(pkglib_python_scripts) \
977         $(nodist_pkglib_python_scripts) \
978         $(python_tests) \
979         $(pkgpython_PYTHON) \
980         $(client_PYTHON) \
981         $(hypervisor_PYTHON) \
982         $(rapi_PYTHON) \
983         $(server_PYTHON) \
984         $(pytools_PYTHON) \
985         $(http_PYTHON) \
986         $(confd_PYTHON) \
987         $(masterd_PYTHON) \
988         $(impexpd_PYTHON) \
989         $(utils_PYTHON) \
990         $(watcher_PYTHON) \
991         $(noinst_PYTHON) \
992         $(qa_scripts)
993
994 srclink_files = \
995         man/footer.rst \
996         test/check-cert-expired_unittest.bash \
997         test/daemon-util_unittest.bash \
998         test/ganeti-cleaner_unittest.bash \
999         test/import-export_unittest.bash \
1000         test/cli-test.bash \
1001         test/bash_completion.bash \
1002         htest/offline-test.sh \
1003         htest/cli-tests-defs.sh \
1004         $(all_python_code) \
1005         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1006
1007 check_python_code = \
1008         $(BUILD_BASH_COMPLETION) \
1009         $(CHECK_IMPORTS) \
1010         $(CHECK_HEADER) \
1011         $(DOCPP) \
1012         $(all_python_code)
1013
1014 lint_python_code = \
1015         ganeti \
1016         ganeti/http/server.py \
1017         $(dist_sbin_SCRIPTS) \
1018         $(python_scripts) \
1019         $(pkglib_python_scripts) \
1020         $(BUILD_BASH_COMPLETION) \
1021         $(CHECK_IMPORTS) \
1022         $(CHECK_HEADER) \
1023         $(DOCPP) \
1024         $(PYTHON_BOOTSTRAP)
1025
1026 standalone_python_modules = \
1027         lib/rapi/client.py \
1028         tools/ganeti-listrunner
1029
1030 pep8_python_code = \
1031         ganeti \
1032         ganeti/http/server.py \
1033         $(dist_sbin_SCRIPTS) \
1034         $(python_scripts) \
1035         $(pkglib_python_scripts) \
1036         $(BUILD_BASH_COMPLETION) \
1037         $(CHECK_HEADER) \
1038         $(DOCPP) \
1039         $(PYTHON_BOOTSTRAP) \
1040         qa
1041
1042 test/daemon-util_unittest.bash: daemons/daemon-util
1043
1044 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1045
1046 test/bash_completion.bash: doc/examples/bash_completion-debug
1047
1048 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1049         sed -f $(REPLACE_VARS_SED) < $< > $@
1050         chmod +x $@
1051
1052 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1053         sed -f $(REPLACE_VARS_SED) < $< > $@
1054         chmod u+x $@
1055
1056 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1057         sed -f $(REPLACE_VARS_SED) < $< > $@
1058         chmod +x $@
1059
1060 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1061         sed -f $(REPLACE_VARS_SED) < $< > $@
1062         chmod +x $@
1063
1064 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1065         sed -f $(REPLACE_VARS_SED) < $< > $@
1066
1067 doc/examples/bash_completion: BC_ARGS = --compact
1068 doc/examples/bash_completion-debug: BC_ARGS =
1069
1070 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1071         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1072         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1073         daemons/ganeti-cleaner \
1074         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1075         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1076           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1077
1078 doc/%.png: doc/%.dot
1079         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1080         $(DOT) -Tpng -o $@ $<
1081
1082 man/footer.man: man/footer.rst
1083         @test -n "$(PANDOC)" || \
1084           { echo 'pandoc' not found during configure; exit 1; }
1085         $(PANDOC) -f rst -t man -o $@ $<
1086
1087 man/footer.html: man/footer.rst
1088         @test -n "$(PANDOC)" || \
1089           { echo 'pandoc' not found during configure; exit 1; }
1090         $(PANDOC) -f rst -t html -o $@ $<
1091
1092 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1093         lib/build/shell_example_lexer.py \
1094         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1095         @echo "Checking $< for hardcoded paths..."
1096         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1097           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1098           exit 1; \
1099         fi
1100         set -e ; \
1101         trap 'echo auto-removing $@; rm $@' EXIT; \
1102         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1103         trap - EXIT
1104
1105 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1106         @test -n "$(PANDOC)" || \
1107           { echo 'pandoc' not found during configure; exit 1; }
1108         set -o pipefail ; \
1109         trap 'echo auto-removing $@; rm $@' EXIT; \
1110         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1111           sed -e 's/\\@/@/g' > $@; \
1112         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1113         $(CHECK_MAN_DASHES) $@; \
1114         trap - EXIT
1115
1116
1117 man/%.html.in: man/%.gen man/footer.html
1118         @test -n "$(PANDOC)" || \
1119           { echo 'pandoc' not found during configure; exit 1; }
1120         set -o pipefail ; \
1121         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1122           sed -e 's/\\@/@/g' > $@
1123
1124 man/%: man/%.in  $(REPLACE_VARS_SED)
1125         sed -f $(REPLACE_VARS_SED) < $< > $@
1126
1127 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1128         sed -f $(REPLACE_VARS_SED) < $< > $@
1129
1130 vcs-version:
1131         if test -d .git; then \
1132           git describe > $@; \
1133         elif test ! -f $@ ; then \
1134           echo "Cannot auto-generate $@ file"; exit 1; \
1135         fi
1136
1137 .PHONY: clean-vcs-version
1138 clean-vcs-version:
1139         rm -f vcs-version
1140
1141 .PHONY: regen-vcs-version
1142 regen-vcs-version:
1143         set -e; \
1144         cd $(srcdir); \
1145         if test -d .git; then \
1146           $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1147           $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1148         fi
1149
1150 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1151         vcs-version $(built_base_sources)
1152         set -e; \
1153         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1154         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1155
1156 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1157         lib/constants.py lib/_autoconf.py lib/luxi.py \
1158         $(CONVERT_CONSTANTS) $(built_base_sources) \
1159         | lib/_vcsversion.py
1160         set -e; \
1161         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1162
1163 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1164         $(built_base_sources)
1165         set -e; \
1166         { cat $< ; \
1167           echo ; \
1168           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1169             echo "import $$name ()" ; \
1170           done ; \
1171         } > $@
1172
1173 lib/_autoconf.py: Makefile | stamp-directories
1174         set -e; \
1175         { echo '# This file is automatically generated, do not edit!'; \
1176           echo '#'; \
1177           echo ''; \
1178           echo '"""Build-time configuration for Ganeti.'; \
1179           echo '';\
1180           echo 'This file is autogenerated by the build process.'; \
1181           echo 'For any changes you need to re-run ./configure (and'; \
1182           echo 'not edit by hand).'; \
1183           echo ''; \
1184           echo '"""'; \
1185           echo ''; \
1186           echo '# pylint: disable=C0301,C0324'; \
1187           echo '# because this is autogenerated, we do not want'; \
1188           echo '# style warnings' ; \
1189           echo ''; \
1190           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1191           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1192           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1193           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1194           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1195           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1196           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1197           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1198           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1199           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1200           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1201           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1202           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1203           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1204           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1205           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1206           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1207           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1208           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1209           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1210           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1211           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1212           echo "KVM_PATH = '$(KVM_PATH)'"; \
1213           echo "IP_PATH = '$(IP_PATH)'"; \
1214           echo "SOCAT_PATH = '$(SOCAT)'"; \
1215           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1216           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1217           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1218           echo "TOOLSDIR = '$(toolsdir)'"; \
1219           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1220           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1221           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1222           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1223           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1224           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1225           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1226           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1227           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1228           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1229           echo "RAPI_USER = '$(RAPI_USER)'"; \
1230           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1231           echo "CONFD_USER = '$(CONFD_USER)'"; \
1232           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1233           echo "NODED_USER = '$(NODED_USER)'"; \
1234           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1235           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1236           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1237           if [ "$(HTOOLS)" ]; then \
1238             echo "HTOOLS = True"; \
1239           else \
1240             echo "HTOOLS = False"; \
1241           fi; \
1242           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1243           echo "XEN_CMD = '$(XEN_CMD)'"; \
1244           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1245         } > $@
1246
1247 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1248         set -e; \
1249         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1250         { echo '# This file is automatically generated, do not edit!'; \
1251           echo '#'; \
1252           echo ''; \
1253           echo '"""Build-time VCS version number for Ganeti.'; \
1254           echo '';\
1255           echo 'This file is autogenerated by the build process.'; \
1256           echo 'For any changes you need to re-run ./configure (and'; \
1257           echo 'not edit by hand).'; \
1258           echo ''; \
1259           echo '"""'; \
1260           echo ''; \
1261           echo '# pylint: disable=C0301,C0324'; \
1262           echo '# because this is autogenerated, we do not want'; \
1263           echo '# style warnings' ; \
1264           echo ''; \
1265           echo "VCS_VERSION = '$$VCSVER'"; \
1266         } > $@
1267
1268 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1269         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1270
1271 $(SHELL_ENV_INIT): Makefile stamp-directories
1272         set -e; \
1273         { echo '# Allow overriding for tests'; \
1274           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1275           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1276           echo; \
1277           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1278           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1279           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1280           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1281           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1282         } > $@
1283
1284 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1285         set -e; \
1286         { echo 's#@PREFIX@#$(prefix)#g'; \
1287           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1288           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1289           echo 's#@BINDIR@#$(bindir)#g'; \
1290           echo 's#@SBINDIR@#$(sbindir)#g'; \
1291           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1292           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1293           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1294           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1295           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1296           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1297           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1298           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1299           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1300           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1301           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1302           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1303           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1304           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1305           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1306           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1307           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1308           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1309           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1310           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1311           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1312           echo; \
1313           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1314           echo '  r $(SHELL_ENV_INIT)'; \
1315           echo '  d'; \
1316           echo '}'; \
1317         } > $@
1318
1319 # Using deferred evaluation
1320 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1321 daemons/ganeti-watcher: MODULE = ganeti.watcher
1322 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1323 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1324 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1325
1326 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1327         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1328         set -e; \
1329         { echo '#!/usr/bin/python'; \
1330           echo '# This file is automatically generated, do not edit!'; \
1331           echo "# Edit $(MODULE) instead."; \
1332           echo; \
1333           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1334           echo; \
1335           echo '# pylint: disable=C0103'; \
1336           echo '# C0103: Invalid name'; \
1337           echo; \
1338           echo 'import sys'; \
1339           echo 'import $(MODULE) as main'; \
1340           echo; \
1341           echo '# Temporarily alias commands until bash completion'; \
1342           echo '# generator is changed'; \
1343           echo 'if hasattr(main, "commands"):'; \
1344           echo '  commands = main.commands # pylint: disable=E1101'; \
1345           echo 'if hasattr(main, "aliases"):'; \
1346           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1347           echo; \
1348           echo 'if __name__ == "__main__":'; \
1349           echo '  sys.exit(main.Main())'; \
1350         } > $@
1351         chmod u+x $@
1352
1353 $(HS_BUILT_TEST_HELPERS): Makefile
1354         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1355         set -e; \
1356         { echo '#!/bin/sh'; \
1357           echo '# This file is automatically generated, do not edit!'; \
1358           echo "# Edit Makefile.am instead."; \
1359           echo; \
1360           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1361         } > $@
1362         chmod u+x $@
1363
1364 stamp-directories: Makefile
1365         $(MAKE) $(AM_MAKEFLAGS) ganeti
1366         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1367         touch $@
1368
1369 # We need to create symlinks because "make distcheck" will not install Python
1370 # files when building.
1371 stamp-srclinks: Makefile | stamp-directories
1372         set -e; \
1373         for i in $(srclink_files); do \
1374                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1375                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1376                 fi; \
1377         done
1378         touch $@
1379
1380 .PHONY: ganeti
1381 ganeti:
1382         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1383
1384 .PHONY: check-dirs
1385 check-dirs: $(GENERATED_FILES)
1386         @set -e; \
1387         find . -type d \( \( -name . \) -o \( \
1388                 -name .git -o \
1389                 -name autom4te.cache \
1390                 \) -prune -o -print \) | { \
1391                 error=; \
1392                 while read dir; do \
1393                         case "$$dir" in \
1394                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1395                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1396                         esac; \
1397                 done; \
1398                 for dir in $(DIRS); do \
1399                         if ! test -d "$$dir"; then \
1400                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1401                                 error=1; \
1402                         fi \
1403                 done; \
1404                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1405         }
1406
1407 .PHONY: check-local
1408 check-local: check-dirs $(GENERATED_FILES)
1409         $(CHECK_PYTHON_CODE) $(check_python_code)
1410         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1411         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1412         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1413         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1414         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1415         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1416                 echo "Incorrect version in README, expected $$expver"; \
1417                 exit 1; \
1418         fi; \
1419         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst; do \
1420                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1421                         "Documents Ganeti version $$expver"; then \
1422                         echo "Incorrect version in $$file, expected $$expver"; \
1423                         exit 1; \
1424                 fi; \
1425         done
1426
1427 .PHONY: hs-check
1428 hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1429         @rm -f test.tix
1430         ./htest/test
1431         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1432
1433 # E111: indentation is not a multiple of four
1434 # E121: continuation line indentation is not a multiple of four
1435 #       (since our indent level is not 4)
1436 # E125: continuation line does not distinguish itself from next logical line
1437 #       (since our indent level is not 4)
1438 # E127: continuation line over-indented for visual indent
1439 #       (since our indent level is not 4)
1440 # note: do NOT add E128 here; it's a valid style error in most cases!
1441 # I've seen real errors, but also some cases were we indent wrongly
1442 # due to line length; try to rework the cases where it is triggered,
1443 # instead of silencing it
1444 # E261: at least two spaces before inline comment
1445 # E501: line too long (80 characters)
1446 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1447
1448 # For excluding pep8 expects filenames only, not whole paths
1449 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1450
1451 LINT_TARGETS = pylint pylint-qa
1452 if HAS_PEP8
1453 LINT_TARGETS += pep8
1454 endif
1455 if HAS_HLINT
1456 LINT_TARGETS += hlint
1457 endif
1458
1459 .PHONY: lint
1460 lint: $(LINT_TARGETS)
1461
1462 .PHONY: pylint
1463 pylint: $(GENERATED_FILES)
1464         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1465         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1466
1467 .PHONY: pylint-qa
1468 pylint-qa: $(GENERATED_FILES)
1469         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1470         cd $(top_srcdir)/qa && \
1471           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1472           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1473
1474 .PHONY: pep8
1475 pep8: $(GENERATED_FILES)
1476         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1477         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1478                 --repeat $(pep8_python_code)
1479
1480 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1481 .PHONY: hlint
1482 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1483         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1484         if tty -s; then C="-c"; else C=""; fi; \
1485         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1486           --ignore "Use first" \
1487           --ignore "Use comparing" \
1488           --ignore "Use on" \
1489           --ignore "Reduce duplication" \
1490           --ignore "Use &&&" \
1491           --ignore "Use void" \
1492           --hint htools/lint-hints \
1493           $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1494
1495 # a dist hook rule for updating the vcs-version file; this is
1496 # hardcoded due to where it needs to build the file...
1497 dist-hook:
1498         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1499         rm -f $(top_distdir)/vcs-version
1500         cp -p $(srcdir)/vcs-version $(top_distdir)
1501
1502 # a distcheck hook rule for catching revision control directories
1503 distcheck-hook:
1504         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1505                 echo "Found revision control files in final archive." 1>&2; \
1506                 exit 1; \
1507         fi
1508         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1509                 echo "Found Python byte code in final archive." 1>&2; \
1510                 exit 1; \
1511         fi
1512         if find $(top_distdir) -name '*~' | grep .; then \
1513                 echo "Found backup files in final archive." 1>&2; \
1514                 exit 1; \
1515         fi
1516 # Empty files or directories should not be distributed. They can cause
1517 # unnecessary warnings for packagers. Directories used by automake during
1518 # distcheck must be excluded.
1519         if find $(top_distdir) -empty -and -not \( \
1520                         -path $(top_distdir)/_build -or \
1521                         -path $(top_distdir)/_inst \) | grep .; then \
1522                 echo "Found empty files or directories in final archive." 1>&2; \
1523                 exit 1; \
1524         fi
1525         if test -n "$(BUILD_RELEASE)" && \
1526            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1527                 echo "Found unreleased version in NEWS." >&2; \
1528                 exit 1; \
1529         fi
1530
1531 # When building a release, stricter checks should be used
1532 distcheck-release dist-release: export BUILD_RELEASE = 1
1533 distcheck-release: distcheck
1534
1535 distrebuildcheck: dist
1536         set -e; \
1537         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1538         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1539         cd $$builddir; \
1540         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1541         cd $(distdir); \
1542         ./configure; \
1543         $(MAKE) maintainer-clean; \
1544         cp $(abs_srcdir)/vcs-version .; \
1545         ./configure; \
1546         $(MAKE) $(AM_MAKEFLAGS)
1547
1548 dist-release: dist
1549         set -e; \
1550         for i in $(DIST_ARCHIVES); do \
1551                 echo -n "Checking $$i ... "; \
1552                 autotools/check-tar < $$i; \
1553                 echo OK; \
1554         done
1555
1556 install-exec-local:
1557         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1558           "$(DESTDIR)${localstatedir}/log/ganeti" \
1559           "$(DESTDIR)${localstatedir}/run/ganeti"
1560
1561 .PHONY: apidoc
1562 if WANT_HTOOLSAPIDOC
1563 apidoc: py-apidoc hs-apidoc
1564 else
1565 apidoc: py-apidoc
1566 endif
1567
1568 .PHONY: py-apidoc
1569 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1570         $(RUN_IN_TEMPDIR) epydoc -v \
1571                 --conf $(CURDIR)/epydoc.conf \
1572                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1573
1574 .PHONY: hs-apidoc
1575 hs-apidoc: $(HS_BUILT_SRCS)
1576         @test -n "$(HSCOLOUR)" || \
1577             { echo 'HsColour' not found during configure; exit 1; }
1578         @test -n "$(HADDOCK)" || \
1579             { echo 'haddock' not found during configure; exit 1; }
1580         rm -rf $(APIDOC_HS_DIR)/*
1581         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1582         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1583         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1584         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1585         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1586         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1587         set -e ; \
1588         cd htools; \
1589         if [ "$(HTOOLS_NOCURL)" ]; \
1590         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1591         else OPTGHC=""; \
1592         fi; \
1593         if [ "$(HTOOLS_PARALLEL3)" ]; \
1594         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1595         fi; \
1596         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1597         for file in $$RELSRCS; do \
1598                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1599                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1600         done ; \
1601         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1602                 -t ganeti-htools -p haddock-prologue \
1603                 --source-module="%{MODULE/.//}.html" \
1604                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1605                 $$OPTGHC \
1606                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1607
1608 .PHONY: TAGS
1609 TAGS: $(GENERATED_FILES)
1610         rm -f TAGS
1611         $(GHC) -e ":etags" -v0 \
1612           $(filter-out -O -Werror,$(HFLAGS)) \
1613           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
1614           $(HS_LIBTEST_SRCS)
1615         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1616           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1617           -path './qa/*.py' | \
1618           etags -l python -a -
1619
1620 .PHONY: coverage
1621 if WANT_HTOOLS
1622 coverage: py-coverage hs-coverage
1623 else
1624 coverage: py-coverage
1625 endif
1626
1627 .PHONY: py-coverage
1628 py-coverage: $(GENERATED_FILES) $(python_tests)
1629         set -e; \
1630         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1631         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1632         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1633         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1634         $(python_tests)
1635
1636 .PHONY: hs-coverage
1637 hs-coverage: $(haskell_tests) htest/hpc-htools
1638         rm -f *.tix
1639         $(MAKE) $(AM_MAKEFLAGS) hs-check
1640         @mkdir_p@ $(COVERAGE_HS_DIR)
1641         hpc combine --union $(HPCEXCL) \
1642           test.tix hpc-htools.tix > coverage-htools.tix
1643         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1644         hpc report coverage-htools.tix
1645         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1646
1647 # Special "kind-of-QA" target for htools, needs special setup (all
1648 # tools compiled with -fhpc)
1649 .PHONY: live-test
1650 live-test: all
1651         set -e ; \
1652         cd htools; \
1653         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1654         rm -f *.tix *.mix; \
1655         ./live-test.sh; \
1656         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1657           --output=live-test.tix ; \
1658         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1659         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1660                 --srcdir=.. $(HPCEXCL) ; \
1661         hpc report --srcdir=.. live-test $(HPCEXCL)
1662
1663 commit-check: distcheck lint apidoc
1664
1665 .PHONY: gitignore-check
1666 gitignore-check:
1667         @if [ -n "`git status --short`" ]; then \
1668           echo "Git status is not clean!" 1>&2 ; \
1669           git status --short; \
1670           exit 1; \
1671         fi
1672
1673 # we don't need the ancient implicit rules:
1674 %: %,v
1675 %: RCS/%,v
1676 %: RCS/%
1677 %: s.%
1678 %: SCCS/s.%
1679
1680 -include ./Makefile.local
1681
1682 # vim: set noet :